ArrowBase = ArrowBase or class(ProjectileBase)
ArrowBase._arrow_units = {}
local mvec1 = Vector3()
local mrot1 = Rotation()
local ids_pickup = Idstring("pickup")
-- My vars
local check_once_bow = false
local fire_arrow = false
local shock_arrow = false
--/My vars
function ArrowBase:_on_collision(col_ray)
	local damage_mult = self._weapon_damage_mult or 1
	local loose_shoot = self._weapon_charge_fail
	if not loose_shoot and alive(col_ray.unit) then
		local client_damage = self._damage_class_string == "InstantExplosiveBulletBase" or alive(col_ray.unit) and col_ray.unit:id() ~= -1
		if Network:is_server() or client_damage then
			-- Check berz aced
			self._ext_damage = managers.player:player_unit():character_damage()
			local health_ratio = self._ext_damage:health_ratio()
			local damage_health_ratio = managers.player:get_damage_health_ratio(health_ratio, weapon_category)

			if damage_health_ratio > 0 then
				local upgrade_name = weapon_category == "saw" and "melee_damage_health_ratio_multiplier" or "damage_health_ratio_multiplier"
				local damage_ratio = damage_health_ratio
				damage_mult = damage_mult * (1 + managers.player:upgrade_value("player", upgrade_name, 0) * damage_ratio)
			end
			-- Check ovk aced
			if managers.player:has_category_upgrade("player", "overkill_all_weapons") or weapon_category == "shotgun" or weapon_category == "saw" then
				damage_mult = damage_mult * managers.player:temporary_upgrade_value("temporary", "overkill_damage_multiplier", 1)
			end
			self._damage_class:on_collision(col_ray, self._weapon_unit or self._unit, self._thrower_unit, self._damage * damage_mult, false, false)

			-- Shock and fire from here

			if not check_once_bow then
				check_once_bow = true
				for values, value in pairs(self:weapon_unit():base()._blueprint or {}) do
					if value == "wpn_fps_bow_long_m_fire" then
						fire_arrow = true
						log('fire_arrow true')
						break
					end
				end
				for values, value in pairs(self:weapon_unit():base()._blueprint or {}) do
					if value == "wpn_fps_bow_long_m_shock" then
						shock_arrow = true
						log('shock_arrow true')
						break
					end
				end
			end
			if alive(col_ray.unit:body("mover_blocker")) then --Must check
				if fire_arrow then
					local fire_dot_data = {
						dot_damage = 5,
						dot_trigger_max_distance = 9000,
						dot_trigger_chance = 100,
						dot_length = 6.1,
						dot_tick_period = 0.5
					}
					local action_data = {}
					action_data.variant = "fire" -- fire taser_tased
					action_data.damage = self._damage * damage_mult
					action_data.attacker_unit = nil -- managers.player:player_unit() -- or nil
					action_data.col_ray = col_ray
					action_data.fire_dot_data = fire_dot_data
					col_ray.unit:character_damage():damage_fire(action_data)
					self._unit:set_slot(0)
					return
				end
				if shock_arrow then
					local action_data = {}
					action_data.damage_effect = 2
					action_data.name_id = 'zeus'
					action_data.damage = 0.1
					action_data.attacker_unit = managers.player:player_unit() -- or nil
					action_data.col_ray = col_ray
					action_data.damage = 1
					action_data.variant = "taser_tased"
					col_ray.unit:character_damage():damage_melee(action_data)
					self._unit:set_slot(0)
					return
				end
			end

		end
	end
	
	if not loose_shoot and tweak_data.projectiles[self._tweak_projectile_entry].remove_on_impact then
		self._unit:set_slot(0)
		return
	end
	self._unit:body("dynamic_body"):set_deactivate_tag(Idstring())
	self._col_ray = col_ray
	self:_attach_to_hit_unit(nil, loose_shoot)
end